Enemy = class('Enemy', Object)

function Enemy:initialize()
	Object.initialize(self)

	local random = math.random(0,3)

	if random == 0 then
		-- left side of screen
		self.x = -16
		self.y = math.random(0, gameHeight)
	end

	if random == 1 then
		-- up side of screen
		self.x = math.random(0, gameWidth)
		self.y = -32
	end

	if random == 2 then
		-- right side of screen
		self.x = gameWidth + 16
		self.y = math.random(0, gameHeight)
	end

	if random == 3 then
		-- down side of screen
		self.x = math.random(0, gameWidth)
		self.y = gameHeight + 32
	end

	self.cBox = Collider:addRectangle(self.x, self.y, 16, 32)

end

function Enemy:draw()
	love.graphics.setColor(0, 255, 60)
	--love.graphics.rectangle("fill", self.x, self.y, 16, 32)
	self.cBox:draw("line")
end

function Enemy:update(dt)

	local pythaOne = (self.x - playerOne.x)^2 + (self.y - playerOne.y)^2
	local pythaTwo = (self.x - playerTwo.x)^2 + (self.y - playerTwo.y)^2

	if pythaOne < pythaTwo then
		self.targetX = playerOne.x
		self.targetY = playerOne.y
	else
		self.targetX = playerTwo.x
		self.targetY = playerTwo.y
	end

	self.speedX = ((self.x - self.targetX) * dt)
	self.speedY = ((self.y - self.targetY) * dt)

	local maxSpeed = 1

	if self.speedX >= maxSpeed then 
		self.speedX = maxSpeed
	end

	if self.speedX <= -maxSpeed then
		self.speedX = -maxSpeed
	end

	if self.speedY >= maxSpeed then 
		self.speedY = maxSpeed
	end 

	if self.speedY <= -maxSpeed then
		self.speedY = -maxSpeed
	end

	self.x = self.x - self.speedX
	self.y = self.y - self.speedY

	self.cBox:moveTo(self.x, self.y)
end