Player = class('Player', Object)

function Player:initialize(player)
	Object.initialize(self)

	if player == 1 then

		self.up    = "w"
		self.down  = "s"
		self.left  = "a"
		self.right = "d"
		self.shoot = "g"

		self.color = {255, 0 , 0}

		self.x     = gameWidth / 2 - 16
		self.y     = gameHeight / 2

		self.num   = 1
		self.id    = "Player One"
	end
	
	if player == 2 then
		self.up    = "up"
		self.down  = "down"
		self.left  = "left"
		self.right = "right"
		self.shoot = "l"

		self.color = {0, 0, 255}

		self.x     = gameWidth / 2 + 16
		self.y     = gameHeight / 2

		self.num   = 2
		self.id    = "Player Two"
	end

	self.direction = "down"
	self.bullets   = {}
	self.energy    = 100
	self.score     = 0
	
end

function Player:draw()

		love.graphics.setColor(self.color)
		love.graphics.rectangle("fill", self.x, self.y, 16, 32)

		for _,v in pairs(self.bullets) do
   			v:draw()
		end

end

function Player:update(dt)

	local speed = 100

	if love.keyboard.isDown(self.up) then
		self.y = self.y - (speed * dt)
		self.direction = "up"
	end

	if love.keyboard.isDown(self.down) then
		self.y = self.y + (speed * dt)
		self.direction = "down"
	end

	if love.keyboard.isDown(self.left) then
		self.x = self.x - (speed * dt)
		self.direction = "left"
	end

	if love.keyboard.isDown(self.right) then
		self.x = self.x + (speed * dt)
		self.direction = "right"
	end

	if love.keyboard.isDown(self.shoot) then
		self.energy = self.energy - 2
		
		self.bullets[#self.bullets + 1] = Projectile:new(self.num, self.direction)
		self.bullets[#self.bullets]:initialize()

	end

	if self.energy <= 0 then 
		self.energy = 0
	end

	if self.energy >= 100 then 
		self.energy = 100
	end

	self.energy = self.energy + 1

	for _,v in pairs(self.bullets) do
   		v:update(dt)
	end

	for i = #self.bullets, 1, -1 do -- reverse-order trick
		local b = self.bullets[i]
		local x, y = b.cBox:center()
		-- Destroy off-screen instances
		if x < 0 or x > gameWidth or y < 0 or y > gameHeight then
			Collider:remove(b.cBox)
			b.cBox = nil
			table.remove(self.bullets, i)
		end
	end

		for i = #zombies, 1, -1 do -- reverse-order trick
		for l = #self.bullets, 1, -1 do
			local z = zombies[i]
			local b = self.bullets[l]
			
			if z == nil then
				break
			end

			if z.cBox:collidesWith(b.cBox) then
				table.remove(zombies, i)
				table.remove(self.bullets, l)
				self.score = self.score + 1
				trace("I, Zombie # " .. i .. " got shot by the rightious " .. self.id .. "!")
			end
		end
	end

end